// Gedenk- und Feiertage nach Jrg Wiegels kalender.js
// Erweitert um Funktionen nach Claus Tndering, W.H. Jefferys, R.H. van Gent,
// Charlie Kluepfel, und E.M. Reingold, N. Dershowitz: Calendrical Calculations
// Angepasst und modifiziert von Oskar Fuhlrott 2007-2008

var AJahr
var AMonat
var ATag
var O=false

var Anzahl= 0
var Daten = new Array()

function Init(Monat,Jahr)
{
  AJahr =Jahr
  AMonat=Monat
  ATag  = 1
}

function Monatslaenge(Monat,Jahr)
{
  return Monat==2? 28+(Jahr%4==0 && Jahr%100>0 || Jahr%400==0?1:0):32-(Math.abs(Monat*2-15)%4+1)/2
  //return 32 - new Date(Jahr, Monat, 32).getDate()
}

function JahresTag(Tag,Monat)
{
  while(Monat > 1)
    Tag += Monatslaenge(Monat--,AJahr)
  return Tag
}

function Rang(Datum)
{
  //return (Datum.Monat*32+Datum.Tag-AMonat*32-ATag+12*32+2)%(12*32)-2
  return Datum.Tag*32+Datum.Monat
}

// Termin-Objekt
function Termin(Art,Tag,Monat,Name)
{
  this.Art   = Art
  this.Tag   = Tag
  this.Monat = Monat
  this.Name  = Name
}

// Tage mit festem Datum
function Fest(Art,Tag,Monat,Name)
{
  if(Monat == AMonat) {
    var Datum = new Termin(Art,Tag,Monat,Name)
    var Zahl = Anzahl
    while(Zahl > 0 && Rang(Datum) < Rang(Daten[Zahl-1])) Zahl--
    ++Anzahl
    for(var Index = Anzahl-1; Index > Zahl; --Index)
      Daten[Index] = Daten[Index-1]
    Daten[Zahl] = Datum
  }
  else Datum = null
}

// N-ter Tag im Jahr = 
function Nter(Art,Tag,Verschub,Name)
{
  Tag += Verschub-Monatslaenge(2,AJahr)
  var Monat = 2
  while(Tag > Monatslaenge(Monat,AJahr))
    Tag -= Monatslaenge(Monat++,AJahr)
  Fest(Art,Tag,Monat,Name)
}

// N-ter bestimmter Wochentag im Monat = 
function Relativ(Art,Tag,Verschub,Wochentag,Name)
{
if(O == true) {
 //alert(Tag+".("+Wochentag+"),"+Name)
}
  Tag +=
    Verschub-(Tag-Math.ceil(Math.floor(AJahr/100)*7/4) +
              Math.floor(AJahr%100*5/4)+2-Wochentag)%7 +
    Monatslaenge(2,AJahr)
  var Monat = 2
  while(Tag > Monatslaenge(Monat,AJahr))
    Tag -= Monatslaenge(Monat++,AJahr)
  Fest(Art,Tag,Monat,Name)
}

// Erster Wochentag im Monat = 
function Erster(Art,Monat,Wochentag,Name)
{
  var Tag = 1
  var Dat = new Date(AJahr, Monat-1, Tag)
  while(Dat.getDay() != Wochentag)
  {
    Dat.setDate(Tag)
    Tag++
  }
  Fest(Art,Tag-1,Monat,Name)
}

// Letzter Wochentag im Monat = 
function Letzter(Art,Monat,Wochentag,Name)
{
  var Tag = Monatslaenge(Monat,AJahr)
  var Dat = new Date(AJahr, Monat-1, Tag)
  while(Dat.getDay() != Wochentag)
  {
    Tag--
    Dat.setDate(Tag)
  }
  Fest(Art,Tag,Monat,Name)
}

// Letzter Werktag im Monat (nicht Sonntag oder Samstag) = 
function LWerktag(Art,Monat,Monatslaenge,Name)
{
  var Tag = Monatslaenge
  var Dat = new Date(AJahr, Monat-1, Tag)
  while((Dat.getDay() == 1) || (Dat.getDay() == 6))
  {
    Tag--
    Dat.setDate(Tag)
  }
  Fest(Art,Tag,Monat,Name)
}

function Saison(Magic,Tag,Monat,Name)
{
  Fest('a',Tag+(Magic>>AJahr%4&1),Monat,Name)  // N&auml;herungsformel f&uuml; Zeitzone 1
            //(Magic>>(AJahr%4))&1. Ergebnisse gepr&uuml;ft f&uuml;r 2002-2014
            // Frhlingsanfang wird voraussichtlich 2015 auf den 21.3. fallen
            // Sommeranfang wird voraussichtlich 2016? auf den 20.6. fallen
}

function Ostern(Art,Verschub,Name)
{
  var Golden = AJahr%19+1
  Relativ(Art,57-(Golden*11-6)%30-(Golden*11%30==6+(Golden > 11?1:0)?1:0),Verschub,0,Name)
}

// Orthodoxes Ostern-relatives Datum nach C. Tndering: ortheast.html
function Ortho(Art,Verschub,Name)
{
  var Golden = AJahr%19
  var P = (Golden*19+15)%30    // number of days from 21 March to the Paschal full moon
  var W = (AJahr+AJahr/4+P)%7  // weekday for the Paschal full moon
  // L is the number of days from 21 March to the Sunday on or
  // before the Pascal full moon (a number between -6 and 28):
  var L = P-W
  var M = 3+(L+40)/44
  var T = L+28 - 31*(M/4)
//  if(Verschub == 0)
//   alert(Art+" Julian "+String(Math.floor(T))+"."+String(Math.floor(M))+"."+Name)
//  var gDat=GregorianFromJD(JDfromJulian(T,M,AJahr))
  var gDat=GregorianFromJD(JDfromJulian(T,M,AJahr))
  if(Verschub == 0)
//alert(Art+" "+gDat.getDate()+"."+String(gDat.getMonth()+1)+"."+Name)
//alert("Verschub "+gDat.getDay()+18+" "+Name)
O=true
  Relativ(Art,JahresTag(gDat.getDay(),gDat.getMonth())+11,Verschub,0,Name)
}

// Diese und die nchste Funktion sind von W.H. Jefferys: Julian Day Numbers
function JDfromJulian(T,M,J)
{
  var A = Math.floor(J/100)
  var B = Math.floor(A/4)
  var C = 2-A+B
  var E = Math.floor(365.25*(J+4716))
  var F = Math.floor(30.6001*(M+1))
  var JD= C+T+E+F-1524.5  // Julian Day
  return JD 
}

// Invalid for years earlier than 1582:
function GregorianFromJD(JD)
{
  var Z = JD+0.5
  var W = Math.floor((Z - 1867216.25)/36524.25)
  var X = Math.floor(W/4)
  var A = Z+1+W-X
  var B = A+1524
  var C = Math.floor((B-122.1)/365.25)
  var D = Math.floor(365.25*C)
  var E = Math.floor((B-D)/30.6001)
  var F = Math.floor(30.6001*E)
  var gDat = new Date()
  gDat.setDate(B-D-F)
  gDat.setMonth(E > 13 ? E-14 : E-2)
  var J = gDat.getMonth() < 2 ? C-4715 : C-4716
  gDat.setYear(J)
  return gDat  // Gregorian date, noon
}

function Julian(Art,Tag,Monat,Name)
{
 var JD=JDfromJulian(Tag,Monat,AJahr)
 var gDat=GregorianFromJD(JD)
//alert("Julian:"+JD+" Gregorian:"+JahresTag(gDat.getDate(),gDat.getMonth()+1))
//alert(Art+" "+Tag+"."+Monat+" - "+gDat.getDate()+"."+String(gDat.getMonth()+1)+"."+Name)
 Fest(Art,gDat.getDate(),(gDat.getMonth()+1),Name)
}

// Jdisches Pessach(=15. Nisan)-relatives Datum nach R.H. van Gent
function Pessach(Art,Verschub,Name)
{
  var dcjg=Math.floor(AJahr/100)-Math.floor(AJahr/400)-2
  var a=(12*AJahr+12)%19
  var b=AJahr%4
  var s=(1979335-313*AJahr)/98496+(765433*a)/492480+b/4
  var q=Math.floor(s)
  var r=s-q;
  var c=(q+3*AJahr+5*b+1)%7
  var dmh=q+dcjg+92
  var p=0
  if((c == 2) || (c == 4) || (c == 6)) p=1           // wegen Adu
  if((c == 1) && (a > 6) && (r >= 1367/2160)) p=2    // wegen Gatarad
  if((c == 0) && (a > 11) && (r >= 23269/25920)) p=1 // wegen Thakpad
  dmh+=p
  //if(AJahr <= 1582) dmh=dmh-dcjg;
  //var w=(c+p+5)%7; 
  var mh=Math.floor((dmh-62)/30.6);
  var dh=Math.floor(dmh-62-30.6*mh)+1;
  mh=mh+2;
  //var w1=w0 < 6 ? w0+1 : 0; 
  //var am=AJahr+3760;
  var RelTag=JahresTag(dh,mh-1)+28
  //if (b*4 == AJahr) RelTag++; //Schaltjahr
//alert(dh+"."+mh+".")
  Nter(Art,RelTag-1,Verschub,"B: "+Name)
  Nter(Art,RelTag,Verschub,"E: "+Name)
}//Pessach

function Remainder(x,y)
{
  return x - y*Math.floor(x/y)
}

// Jdisches Rosch haSchanah(=1. Tischri = N-ter Sept.)-relatives Datum
function Rosch(Art,Verschub,Name)  // nach William H. Jefferys
{
  var Golden = AJahr%19+1
  //var N = ((Y/100-Y/400-2+765433/492480*(12G%19)+(Y%4)/4-(313AJahr+89081)/98496)/1
  // Abkrzung fr den Zeitraum 1900-2099 nach W.H. Jefferys:
  var NF = 6.057778996+1.554241797*Remainder(12*Golden,19)+0.25*Remainder(AJahr-1900,4)-0.003177794*(AJahr-1900)
  var N = Math.floor(NF)
  var Frac = NF-N
  var M=9
  if(N > 30){M++;n-=30}
//alert(N+"."+M+".")
  var RelTag=JahresTag(N,M-1)+28
  //if ((AJahr%4)*4 == AJahr) RelTag++; //Schaltjahr
  var w=new Date(AJahr,M-1,N).getDay()
  //var w0=w1 < 0 ? 6 : w1-1;
  switch(w)
  {
    case 0: //So
    case 3: //Mi
    case 5: //Fr
      RelTag+=1
      break
    case 1: //Mo
      if(Frac >= 23269/25920 && Remainder(12*Golden,19) > 6)
        RelTag+=1
      break
    case 2: //Di
      if(Frac >= 1367/2160 && Remainder(12*Golden,19) > 6)
        RelTag+=2
      break
  }
  Nter(Art,RelTag-1,Verschub,"B: "+Name)
  Nter(Art,RelTag,Verschub,"E: "+Name)
}//Rosch

// Persisches Norus(=1. Farvardin)-relatives Datum
function Norus(Art,Verschub,Name)  // nach Homam Hosseinis persian_modern_jd0()
{
  /*
  var PJahr = AJahr
  //var PJahr = AJahr - 621
  var epBase = PJahr - 474
  var epYear = 474 + (epBase+282000000) % 2820
  var JD=(epYear*31-5)/1128+(epYear-1)*365+((PJahr-epYear)/2820)*1029983+1948320 //Persian epoch
  var gDat=GregorianFromJD(JD)
  var RelTag=JahresTag(gDat.getDate(),gDat.getMonth())+28
  */
  var RelTag=49+28  // Gilt so bis 2024
  Nter(Art,RelTag-1,Verschub,"B: "+Name)
  Nter(Art,RelTag,Verschub,"E: "+Name)
}//Norus

//---Funktionen zum chinesischen Neujahrsfest nach Charlie Kluepfel---
var dr=Math.atan(1)/45

// Normalize a degree measure
function fnnm(x)
{
 return (x - 360*Math.floor(x/360))
}

// trig functions in degrees
function fnsn(x)
{
  return Math.sin(x*dr)
}

function fncs(x)
{
  return Math.cos(x*dr)
}

function wSolst(ys, chTZ)  //chTZ in hours; + = west
{
  var LO = 270
  var t = (365.2422 * (ys + LO / 360) - 693878.7) / 36525
  var PE = .00134 * fncs(22518.7541 * t + 153)
  PE = PE + .00154 * fncs(45037.5082 * t + 217) + .002 * fncs(32964.3577 * t + 313) + .00178 * fnsn(20.2 * t + 231)
  var DT = 1
  var L,m
  while (Math.abs(DT * 36525) > .001) {
    L = 279.6967 + 36000.76892 * t + .0003025 * t * t
    m = 358.476 + 35999.04975 * t - .00015 * t * t - .0000033 * t * t * t
    L = L + (1.91946 - .004789 * t - .000014 * t * t) * fnsn(m) + (.020094 - .0001 * t) * fnsn(2 * m) + .000293 * fnsn(3 * m)
    L = L - .00479 * fnsn(fnnm(259.18 - 1934.142 * t)) - .00569 + PE + .00179 * fnsn(351 + 445267.1142 * t - .00144 * t * t)
    L = fnnm(L)
    DT = (fnnm(LO - L + 180) - 180) / 36525
    t = t + DT
  } // LOOP WHILE ABS(DT * 36525) > .001
  var chJD = t * 36525 + 2415020 - (.41 + 1.2053 * t + .4992 * t * t) / 1440 - chTZ / 24
//alert(chJD+","+t+","+PE+","+DT)
  return Math.floor(chJD + .5)
}//wSolst

function solTerm(y, chTZ, LO)
{
  if(LO >= 270)
    ys = y - 1
  else
    ys = y
  var t = (365.2422 * (ys + LO / 360) - 693878.7) / 36525
  var PE = .00134 * fncs(22518.7541 * t + 153)
  PE += .00154 * fncs(45037.5082 * t + 217) + .002 * fncs(32964.3577 * t + 313) + .00178 * fnsn(20.2 * t + 231)
  var DT = 1
  var ys,L,m,chJD
  while (Math.abs(DT * 36525) > .001) {
    L = 279.6967 + 36000.76892 * t + .0003025 * t * t
    m = 358.476 + 35999.04975 * t - .00015 * t * t - .0000033 * t * t * t
    L = L + (1.91946 - .004789 * t - .000014 * t * t) * fnsn(m) + (.020094 - .0001 * t) * fnsn(2 * m) + .000293 * fnsn(3 * m)
    L = L - .00479 * fnsn(fnnm(259.18 - 1934.142 * t)) - .00569 + PE + .00179 * fnsn(351 + 445267.1142 * t - .00144 * t * t)
    L = fnnm(L)
    DT = (fnnm(LO - L + 180) - 180) / 36525
    t = t + DT
  } // LOOP WHILE ABS(DT * 36525) > .001
  chJD = t * 36525 + 2415020 - (.41 + 1.2053 * t + .4992 * t * t) / 1440 - chTZ / 24
  return Math.floor(chJD + .5)
}//solTerm

function nextNewMoon(j1, chTZ) {
  var d = j1 - 2415020
  var t = d / 36525
  var k = (j1 - 2415020.759) / 29.53058868; k = Math.floor(k) - 1
  var jdNo = 0
  var m,mp,F
  while (jdNo <= j1){
    m = fnnm(359.22 + 29.10535608 * k)
    mp = fnnm(306.03 + 385.8169181 * k + .01073 * t * t + .00001236 * t * t * t)
    F = fnnm(21.2964 + 390.67050646 * k - .0016528 * t * t)

    jdNo = 2415020.75933 + 29.53058868 * k + .0001178 * t * t
    jdNo += .1734 * fnsn(m)
    jdNo += .0021 * fnsn(2 * m)
    jdNo -= .4068 * fnsn(mp)
    jdNo += .0161 * fnsn(2 * mp)
    jdNo += .0104 * fnsn(2 * F)
    jdNo -= .0051 * fnsn(m + mp)
    jdNo -= .0074 * fnsn(m - mp)
    jdNo += .001  * fnsn(2 * F - mp)

    jdNo -= (.41 + 1.2053 * t + .4992 * t * t) / 1440
    jdNo -= chTZ / 24
    jdNo = Math.floor(jdNo + .5)

    k++
  } // LOOP UNTIL jdNo > j1
  return jdNo
}//nextNewMoon

// Chinesische Neujahrsberechnung
function China(Art,Verschub,Name) {
  var Jahre = new Array (
    "der Ratte",  "des Ochsen", "des Tigers", "des Kaninchens",
    "des Drachen", "der Schlange", "des Pferdes", "der Ziege",
    "des Affen", "des Hahns", "des Hundes", "des Schweins")

  var chTZ = -8  // Chinese Time Zone -- hours (since 1928)

  var s1 = wSolst(AJahr-1,chTZ) // preceding winter solstice JD
  var s2 = wSolst(AJahr,chTZ)   // current winter solstice JD
  var solT1 = solTerm(AJahr, chTZ, 300)  // solar term 1 - begin of Aquarius
  var solT2 = solTerm(AJahr, chTZ, 330)  // solar term 2 - end of Aquarius
//alert(s1+","+s2+","+solT1+","+solT2)
  // new moons:
  var m1 = nextNewMoon(s1, chTZ)
  var m2 = nextNewMoon(m1, chTZ)
  var m3 = nextNewMoon(m2, chTZ)
  var m12 = nextNewMoon(s2, chTZ)
//alert(m1+","+m2+","+m3+","+m12)

  var NY = m2  // Proposed JD of new year
  if(Math.floor((m12 - m1)/ 29.530588 + .5) == 13)
    if(solT1 >= m2 || solT2 >= m3)
      NY = m3

  var cw0, cw1, cw2, cw3
  if(NY > 2299160)
  {
    cw0= Math.floor((NY - 1867216.25)/36524.25)
    cw0= NY + 1 + cw0 - Math.floor(cw0/4)
  }
  else
    cw0= NY

  cw0 += 1524
  cw1 = Math.floor((cw0 - 122.1)/365.25)
  cw2 = Math.floor(365.25*cw1)
  cw3 = Math.floor((cw0 - cw2)/30.6001)
  var d = cw0 - cw2 - Math.floor(30.61*cw3) // the day of Chinese New Year
  var y = cw1 - 4716 // the year
  var m = cw3 - 1    // the month of Chinese New Year
  if(m > 12)
    {m -= 12; y += 1}

  // animal number:
  var c = (y-4) % 12
  var cPrev = (y-5) % 12

  var d0 = d-1
  var m0 = m
  if (d0 < 1)
  { d0=31; m0--} 
  var d15 = d+14
  var m15 = m
  if (d15 > Monatslaenge(m,AJahr))
  { d15-=Monatslaenge(m,AJahr); m15++ } 
//alert(d+"."+m+"."+AJahr)
  Fest(' ', d0, m0,'Ende des chinesischen Jahrs '+Jahre[cPrev])
  Fest('x', d,  m, 'Frhlings-/Neujahrsfest, 1. Tag des Jahrs '+Jahre[c])
  Fest('x',d15,m15, 'Laternenfest, 15. Tag des Neujahrsfests des Jahrs '+Jahre[c])
}//China

function Termine()
{
  // 'g' = gesetzlich
  // 'a' = astronomisch
  // 'c' = christlich
  // 'k' = katholisch
  // 'e' = evangelisch
  // 'o' = orthodox
  // 'j' = jdisch
  // 'i' = ~islamisch
  // 'p' = persisch
  // 'x' = chinesisch
  // ' ' = unspezifiziert
  Ostern('k',-48,'Rosenmontag')
  Ostern('k',-47,'Fastnacht')
  Ostern('k',-46,'Aschermittwoch')
  Ostern('c', -7,'Palmsonntag') // christlich
  Ostern('c', -3,'Grndonnerstag') // christlich
  Ostern('g', -2,'Karfreitag')
  Ostern('c',  0,'Ostersonntag') // christlich
  Ostern('g',  1,'Ostermontag')
  Ostern('k',  7,'Weier Sonntag') //katholisch
  Ostern('g', 39,'Christi Himmelfahrt')
  Ostern('c', 49,'Pfingstsonntag') // christlich
  Ostern('g', 50,'Pfingstmontag') // christlich
  Ostern('k', 56,'Dreifaltigkeitssonntag (Trinitatis)') // katholisch
  Ostern('g', 60,'Fronleichnam (BW,BY,HE,NW,RP,SL,SN z.T.,TH z.T.)') // katholisch
  Ortho('o', -2,'orthodox. Karfreitag')
  Ortho('o',  0,'orthodox. Ostersonntag')
  Ortho('o',  1,'orthodox. Ostermontag')
  Ortho('o', 39,'orthodox. Christi Himmelfahrt')
  Ortho('o', 49,'orthodox. Pfingstsonntag')
  Ortho('o', 50,'orthodox. Pfingstmontag')
//  Julian('o', 6, 1,'orthodox. Epiphanias')
  Fest(  'o', 6, 1,'orthodox. Heiliger Abend')
  Fest(  'o', 7, 1,'Fest der Erscheinung des Herrn (orthodox. Weihnachten)')
  Fest(  'o',19, 1,'orthodox. Theophanie (Epiphanias)')
//  Julian('o', 2, 2,'orthodox. Mari Lichtmess')
  Fest(  'o',15, 2,'orthodox. Mari Lichtmess')
//  Julian('o',25, 3,'orthodox. Mari Verkndigung')
  Fest(  'o', 7, 4,'orthodox. Mari Verkndigung')
//  Julian('o', 6, 8,'orthodox. Verklrung Christi')
  Fest(  'o',19, 8,'orthodox. Verklrung Christi')
//  Julian('o',15, 8,'orthodox. Mari Entschlafen')
  Fest(  'o',28, 8,'orthodox. Mari Entschlafen')
//  Julian('o', 8, 9,'orthodox. Mari Geburt')
  Fest(  'o',21, 9,'orthodox. Mari Geburt')
//  Julian('o',14, 9,'orthodox. Fest der Kreuzerhhung')
  Fest(  'o',27, 9,'orthodox. Fest der Kreuzerhhung')
//  Julian('o',21,11,'orthodox. Vorstellung der Jungfrau Maria im Tempel')
  Fest(  'o', 4,12,'orthodox. Vorstellung der Jungfrau Maria im Tempel')
//  Julian('o',24,12,'orthodox. Heiligabend')
//  Julian('o',25,12,'orthodox. Weihnachten')
  Pessach('j',-30,'Purim') // jdisch
  Pessach('j',  0,'Pessach 1. Tag') // jdisch
  Pessach('j',  1,'Pessach 2. Tag')
  Pessach('j',  6,'Pessach 7. Tag')
  Pessach('j',  7,'Pessach 8. Tag')
  Pessach('j', 50,'Schawuoth, Wochenfest 1. Tag')
  Pessach('j', 51,'Schawuoth 2. Tag')
  Pessach('j',112,'Fasten')
  Pessach('j',247,'Chanukkah, Lichterfest 1. Tag') // jdisch
  Pessach('j',254,'Chanukkah 8. Tag')
  //Rosch('j', 83,'Chanukkah, Lichterfest 1. Tag') // jdisch
  //Rosch('j', 90,'Chanukkah 8. Tag')
  Rosch('j',  0,'Rosch Haschanah 1. Tag') // jdisch
  Rosch('j',  1,'Rosch Haschanah 2. Tag')
  Rosch('j',  9,'Jom Kippur, Vershnungstag') // jdisch
  Rosch('j', 14,'Sukkoth, Laubhttenfest 1. Tag') // jdisch
  Rosch('j', 15,'Sukkoth 2. Tag')
  Rosch('j', 17,'(Sukkoth 4. Tag)')
  Rosch('j', 21,'Schemini Azareth, Schlussfest') // jdisch
  Rosch('j', 22,'Simchat Thora, Gesetzesfreude')     // jdisch
  Norus('p',  0,'persisches Neujahr, 1. Tag Norus') // persisch
  Norus('p',  3,'4. Tag Norus (Newruz, Norooz)')
  China()  // chinesisch

  Fest('g', 1, 1,'Neujahr')
  Fest('k', 1, 1,'Welt-Friedenstag')
  Fest(' ', 4, 1,'Welttag der Brailleschrift') //
  Fest('k', 6, 1,'Heilige Drei Knige (BW, BY, ST)')
  Fest('k', 6, 1,'Afrikatag')
  Fest(' ',25, 1,'Welt-Lepra-Tag') // UNO
  Fest(' ',27, 1,'Tag des Gedenkens an die Opfer des Nationalsozialismus')
  //Fest(' ', 6, 2,'Internationaler Tag gegen Genitalverstmmelung')
  Fest(' ',11, 2,'Welttag der Kranken')
  Fest(' ',12, 2,'Internationaler Tag gegen den Einsatz von Kindersoldaten')
  Fest(' ',14, 2,'Valentinstag')
  Fest(' ',21, 2,'Internationaler Tag der Muttersprache')
  Fest(' ',21, 2,'Welttag der Gstefhrer')
  if(Monatslaenge(2,AJahr+(AMonat > 2?1:0))>28) Fest(' ',29, 2,'Schalttag')
  Fest(' ', 3, 3,'Tag des Artenschutzes')
  Fest(' ', 8, 3,'Welt-Frauentag') // UNO
  Fest(' ',11, 3,'Welttag der Organspende')
  Fest(' ',15, 3,'Tag des Verbrauchers') // EU?
  Fest('k',19, 3,'Josef') // kath.
  Fest(' ',21, 3,'Internationaler Tag zur Beseitigung der Rassendiskriminierung') // UNO
  Fest(' ',21, 3,'Internationaler Tag des Waldes') // UNO
  Fest(' ',22, 3,'Welt-Wassertag') // UNO
  Fest(' ',23, 3,'Welttag der Meteorologie') // WMO
  Fest('k',25, 3,'Verkndigung des Herrn') // kath.
  Fest(' ',27, 3,'Welt-Theatertag')
  Fest(' ', 2, 4,'Internationaler Kinderbuchtag')
  //Fest(' ', 6, 4,'Welt-Olympiatag')
  Fest(' ', 7, 4,'Welt-Gesundheitstag') // WHO
  Fest(' ',11, 4,'Welt-Parkinsontag')
  Fest(' ',21, 4,'Internationaler Tag der Ruhe')
  Fest(' ',21, 4,'Welttag des Baums') // 25. 4.
  Fest(' ',22, 4,'Welttag der Erde')
  Fest(' ',23, 4,'Tag des deutschen Bier-Reinheitsgebots')
  Fest(' ',23, 4,'Welttag des Buches und des Urheberrechts') // UNESCO
  Fest(' ',24, 4,'Welttag des Versuchstiers')
  Fest(' ',25, 4,'Welt-Malariatag')
  Fest(' ',25, 4,'Internationaler Tag des Baumes')
  Fest(' ',25, 4,'Internationaler Tag gegen Lrm')
  Fest(' ',26, 4,'Welttag des geistigen Eigentums')
  Fest(' ',29, 4,'Internationaler Tag des Tanzes')
  Fest('g', 1, 5,'Internationaler Tag der Arbeit') // UNO
  Fest(' ', 3, 5,'Welttag der Pressefreiheit') // UNO
  Fest(' ', 3, 5,'UNEP Tag der Sonne') // UNEP
  Fest(' ', 4, 5,'Florianitag - Welt-Feuerwehrtag')
  Fest(' ', 5, 5,'Europatag')
  Fest(' ', 5, 5,'Tag des herzkranken Kindes')
  Fest('k', 6, 5,'Welttag der geistlichen Berufe')
  Fest(' ', 6, 5,'Antidittag')
  Fest(' ', 8, 5,'Internationaler Tag des Friedens')
  Fest(' ', 8, 5,'Internationaler Rotkreuztag')
  Fest(' ',12, 5,'Internationaler Tag der Krankenpflege')
  Fest('k',11, 5,'1. der Eisheiligen (Mamertus)')
  Fest('k',12, 5,'2. der Eisheiligen (Pankratius)')
  Fest('k',13, 5,'3. der Eisheiligen (Servatius)')
  Fest('k',14, 5,'4. der Eisheiligen (Bonifatius)')
  Fest('k',15, 5,'5. der Eisheiligen (Sophie)')
  Fest(' ',15, 5,'Internationaler Tag der Familie') // UNO
  Fest(' ',15, 5,'Internationaler Tag der Kriegsdienstverweigerer')
  Fest(' ',17, 5,'Welttag des Fernmeldewesens') // ITU
  //Fest(' ',18, 5,'Internationaler Museumstag')
  Fest(' ',21, 5,'Welttag fr kulturelle Entwicklung') // UNESCO
  Fest(' ',22, 5,'Internationaler Tag zur Erhaltung der Artenvielfalt') // UNO
  Fest(' ',23, 5,'Tag des Grundgesetzes')
  Fest(' ',25, 5,'Tag der Freiheit Afrikas') // UNO
  Fest(' ',28, 5,'Internationaler Spieltag')
  Fest(' ',31, 5,'Welt-Nichtrauchertag') // WHO
  Fest(' ', 1, 6,'Internationaler Kindertag') // UNO
  Fest(' ', 1, 6,'Internationaler Tag der Milch') // FAO
  Fest(' ', 2, 6,'Internationaler Hurentag')
  Fest(' ', 5, 6,'Welttag der Umwelt') // UNO
  Fest(' ', 6, 6,'Tag der Sehbehinderten')
  Fest(' ', 8, 6,'Welt-Hirntumor-Tag')
  Fest(' ',11, 6,'Tag des Gartens')
  Fest(' ',12, 6,'Welttag gegen Kinderarbeit') // ILO
  Fest(' ',14, 6,'Welt-Blutspendetag')
  Fest(' ',17, 6,'Nationaler Gedenktag des Deutschen Volkes')
  Fest(' ',17, 6,'Internationaler Tag zur Bekmpfung der Wstenbildung') // UNO
  Fest(' ',20, 6,'Internationaler Tag des Flchtlings') // UNHCR
  Fest(' ',20, 6,'Welt-Jongliertag')
  Fest(' ',21, 6,'Internationaler Tag der selbst gemachten Musik')
  Fest(' ',21, 6,'Tag des Schlafes')
  Fest(' ',24, 6,'Johannistag')
  Fest('k',24, 6,'Johannes der Tufer') // kath.
  Fest(' ',26, 6,'Internationaler Tag gegen Drogenmissbrauch und unerlaubten Suchtstoffverkehr') // UNO
  Fest(' ',26, 6,'Internationaler Tag zur Untersttzung der Folteropfer') // UNO
  Fest(' ',27, 6,'Siebenschlfer')
  Fest('k',29, 6,'Peter und Paul') // katholisch
  Fest(' ',11, 7,'Welt-Bevlkerungstag') // UNDP
  Fest(' ',20, 7,'Gedenktag zum 20. Juli 1944')
  Fest('k',24, 7,'Christopherus') // katholisch
  Fest('k', 6, 8,'Verklrung des Herrn') // katholisch
  Fest('g', 8, 8,'Friedensfest (nur in Augsburg)')
  Fest(' ', 9, 8,'Internationaler Tag der indigenen Vlker') // UNO
  Fest(' ',12, 8,'Internationaler Tag der Jugend') // UNO
  Fest(' ',13, 8,'Jahrestag des Mauerbaus 1961')
  Fest(' ',13, 8,'Internationaler Linkshndertag')
  Fest('g',15, 8,'Mari Himmelfahrt (SL, BY z.T.)') // katholisch
  //Fest(' ',24, 8,'Tag der Vereinten Nationen') // UNO 24.10.
  Fest(' ', 1, 9,'Anti-Kriegstag') // DGB
  Fest(' ', 5, 9,'Deutscher Kopfschmerztag')
  Fest(' ', 8, 9,'Welt-Bildungstag') // UNESCO
  Fest(' ', 9, 9,'Tag des alkoholgeschdigten Kindes')
  Fest(' ',10, 9,'Welt-Suizid-Prventionstag') // WHO
  Fest('k',24, 9,'Kreuzerhhung') // katholisch
  Fest(' ',16, 9,'Internationaler Tag zum Schutz der Ozonschicht') // UNO
  Fest(' ',20, 9,'Deutscher Weltkindertag')
  Fest(' ',21, 9,'Welt-Alzheimer-Tag')
  Fest(' ',21, 9,'Tag der Ersten Hilfe')
  Fest(' ',21, 9,'Welt-Friedenstag')
  Fest(' ',22, 9,'Autofreier Tag in Europa')
  Fest(' ',22, 9,'Welttag des Meeres')
  Fest(' ',23, 9,'Deutscher Lungentag')
  Fest(' ',24, 9,'Tag der Raumfahrt')
  Fest(' ',25, 9,'Tag der Zahngesundheit')
  Fest(' ',26, 9,'Europischer Tag der Sprachen')
  Fest(' ',27, 9,'Welt-Tourismustag') // UNO
  Fest(' ',24, 9,'Tag des bersetzens')
  Fest(' ', 1,10,'Internationaler Tag der lteren Menschen') // UNO
  Fest(' ', 1,10,'Welt-Musiktag') // UNESCO
  Fest(' ', 1,10,'Welt-Vegetariertag')
  Fest('g', 3,10,'Tag der deutschen Einheit')
  //Fest(' ', 4,10,'Tag des Flchtlings') // 28.9., 1.10.1999
  Fest(' ', 4,10,'Welt-Tierschutztag')
  Fest(' ', 5,10,'Tag der Epilepsie')
  Fest(' ', 5,10,'Welt-Posttag') // UNO
  Fest(' ', 5,10,'Welttag des Lehrers') // UNO
  Fest(' ', 8,10,'Welt-Hospiztag')
  Fest(' ', 9,10,'Tag des Weltpostvereins') // UPU
  Fest(' ',11,10,'Deutscher Lungentag')
  Fest(' ',12,10,'Welt-Rheumatag')
  Fest(' ',14,10,'Deutscher Hospiztag')
  Fest(' ',14,10,'Welttag der Standards') // ISO
  Fest(' ',15,10,'Welttag der geistigen Gesundheit') // WHO
  Fest(' ',15,10,'Tag gegen die Todesstrafe') // Amnesty
  Fest(' ',15,10,'Tag des weien Stockes')
  Fest(' ',16,10,'Welt-Ernhrungstag') // FAO
  Fest(' ',17,10,'Internationaler Tag fr die Beseitigung der Armut') // UNO
  Fest(' ',20,10,'Welt-Osteoporosetag')
  Fest(' ',22,10,'Welttag des Stotterns')
  Fest(' ',24,10,'Tag der Vereinten Nationen') // UNO
  Fest(' ',24,10,'Welttag der Information ber Entwicklungsfragen') // UNO
  Fest(' ',24,10,'Deutscher Tag der Bibliotheken')
  Fest(' ',28,10,'Welt-Poliotag') // UNICEF/WHO
  Fest(' ',29,10,'Welt-Psoriasistag')
  Fest(' ',29,10,'Internationaler Internettag')
  Fest('g',31,10,'Reformationstag (BB, MV, SN, ST, TH)') // protestantisch
  Fest(' ',31,10,'Halloween')
  Fest('g', 1,11,'Allerheiligen (BW, BY z.T., NW, RP, SL)') // katholisch
  Fest('k', 2,11,'Allerseelen') // katholisch
  Fest(' ', 3,11,'Welt-Mnnertag')
  Fest('c', 3,11,'Hubertustag')
  Fest(' ', 8,11,'Welt-Putzfrauentag')
  Fest(' ', 9,11,'Tag des Mauerfalls 1989')
  Fest(' ', 9,11,'Tag der Erfinder')
  Fest(' ',10,11,'Weltwissenschaftstag fr Frieden und Entwicklung') // UNO
  Fest('c',11,11,'Martinstag') // christlich
  Fest(' ',11,11,'Beginn von Karneval und Fasching')
  Fest(' ',14,11,'Welt-Diabetes-Tag') // Deutscher Diabetiker-Bund/WHO
  Fest(' ',15,11,'Tag der Autoren hinter Gittern') // PEN
  Fest(' ',16,11,'Internationaler Tag der Toleranz') // UNESCO
  Fest(' ',19,11,'Welt-Toilettentag')
  Fest(' ',20,11,'Welttag der Industrialisierung Afrikas') // UNO
  Fest(' ',20,11,'Tag der Kinderrechte') // UNESCO
  Fest(' ',20,11,'Deutscher Lebertag')
  Fest(' ',21,11,'Welt-Fernsehtag')
  Fest(' ',23,11,'Internationaler Tag gegen Gewalt gegen Frauen') // UNO
  Fest(' ',26,11,'Welttag der Zeitschriften')
  Fest(' ',29,11,'Internationaler Tag der Solidaritt mit dem palstinensischen Volk') // UNO
  Fest(' ', 1,12,'Welt-AIDS-Tag') // WHO
  Fest(' ', 2,12,'Internationaler Tag der Abschaffung der Sklaverei') // UNO
  Fest(' ', 3,12,'Internationaler Tag der Behinderten') // UNO
  Fest('k', 4,12,'Barbara') // kath.
  Fest(' ', 5,12,'Internationaler Entwickungshelfertag fr die wirtschaftliche und soziale Entwicklung') // UNO
  Fest(' ', 5,12,'Welt-Bodentag')
  Fest('c', 6,12,'Nikolaus') // christlich
  Fest(' ', 7,12,'Internationaler Tag der zivilen Luftfahrt') // ICAO
  Fest('c', 8,12,'Mari Empfngnis') // christlich
  Fest('k',10,12,'Tag der unschuldigen Kinder') // kath.
  Fest(' ',10,12,'Tag der Menschenrechte') // UNO
  Fest(' ',15,12,'Welt-Kinderfernsehtag')
  Fest(' ',18,12,'Internationaler Tag der Migranten') // UNO
  Fest('c',24,12,'Heiligabend') // christlich
  Fest('g',25,12,'1. Weihnachtstag') // christlich
  Fest('g',26,12,'2. Weihnachtstag') // christlich
  Fest('k',26,12,'Stephanstag') // kath.
  Fest('k',27,12,'Johannes Apostel') // kath.
  Fest(' ',29,12,'Internationaler Tag der biologischen Vielfalt') // UNO
  Fest('c',31,12,'Silvester') // christlich
  // Parameter der Funktion Relativ: Art, Verschub, 0, Wochentag, Name
  // Wochentag: 0=Sonntag, 1=Montag, 2=Dienstag, 3=Mittwoch, 4=Donnerstag, 5=Freitag, 6=Samstag
  // TageVorher: 0=Jan,31=Feb,59=Mr,90=Apr,120=Mai,151=Jun,181=Jul,212=Aug,273=Sep,242=Okt,304=Nov,334=Dez
  // Verschub: 28=Mr,130=Jul,192=Sep,222=Okt
  Relativ(' ', 28,0,0,'Welttag der Kranken') // 1. Sonntag im Mrz
  Relativ(' ', 28,0,5,'Welt-Gebetstag der Frauen') // 1. Freitag im Mrz
  Relativ(' ', 42,0,0,'Welttag der Invaliden') // 3. Sonntag im Mrz
  Relativ(' ', 59,0,3,'Tag der lteren Generation') // 1. Mittwoch im April
  Relativ(' ', 68,0,0,'Welt-Lachtag') //1. Sonntag im Mai
  Relativ(' ', 68,0,2,'Welt-Asthma-Tag') //1. Dienstag im Mai
  Relativ(' ', 75,0,0,'Muttertag') //2. Sonntag im Mai
  Relativ(' ', 75,0,6,'Europischer Weltladentag') //2. Samstag im Mai
  Relativ(' ',100,0,6,'Tag der Organspende') // WHO 1. Samstag im Juni
  Relativ(' ',130,0,6,'Internationaler Tag der Kooperativen') // UNO 1. Samstag im Juli
  Relativ(' ',199,0,0,'Tag der Heimat') // 2. Sonntag im September
  Relativ(' ',199,0,0,'Tag des offenen Denkmals') // 2. Sonntag im September
  Relativ(' ',199,0,6,'Tag der deutschen Sprache') // 2. Samstag im September
  Relativ(' ',206,0,0,'Tag des Geotops') // 3. Sonntag im September
  Relativ(' ',206,0,2,'Internationaler Tag des Friedens') // UNGA 3. Dienstag im September
  Relativ(' ',220,0,0,'Erntedankfest') // 1. Sonntag nach dem 29. September
  Relativ(' ',222,0,1,'Welttag des Wohn- und Siedlungswesens("Habitat-Tag")') // UNO 1. Montag im Oktober
  Relativ(' ',229,0,3,'Internationaler Tag der Katastrophenvorbeugung') // UNO 2. Mittwoch im Oktober
  Relativ('g',264,0,0,'Volkstrauertag') // zwei Sonntage vor dem 1. Advent
  Relativ('g',267,0,3,'Bu- und Bettag (nur SN)') // prot., Mittwoch vor 23.11. bzw. 11 Tage vor 1. Advent
  Relativ('e',271,0,0,'Totensonntag/Ewigkeitssonntag') // protest., Sonntag vor dem 1. Advent
  Relativ('c',278,0,0,'1. Advent') // christlich, Sonntag zwischen dem 27. November und dem 3. Dezember
  Relativ('c',285,0,0,'2. Advent') // christlich
  Relativ('c',292,0,0,'3. Advent') // christlich
  Relativ('c',299,0,0,'4. Advent') // christlich
  Relativ(' ',286,0,0,'Welt-Gedenktag fr alle verstorbenen Kinder') // 1. Sonntag im Dezember
  Erster(' ', 4,3,'Tag der lteren Generation') // am ersten Mittwoch im April
  Letzter(' ', 1,0,'Welt-Lepra-Tag') // am letzten Sonntag im Januar
  Letzter(' ', 3,0,'Beginn der Sommerzeit: 2h-->3h') // am letzten Sonntag im Mrz
  Letzter(' ', 4,4,'Mdchen-Zukunftstag') // am letzten Donnerstag im April
  Letzter(' ', 4,0,'Welttag der Partnerstdte') // am letzten Sonntag im April
  Letzter(' ', 6,0,'Tag der Architektur') // am letzten Sonntag im Juni
  Letzter(' ', 7,5,'Tag des Systemadministrators') // am letzten Freitag im Juli
  Letzter(' ', 9,0,'Internationaler Tag der Gehrlosen') // am letzten Sonntag im September
  Letzter(' ', 9,5,'Tag des Deutschen Butterbrotes') // am letzten Freitag im September
  Letzter(' ',10,0,'Beginn der Winterzeit: 3h-->2h') // am letzten Sonntag im Oktober
  Letzter(' ',11,6,'Kauf-Nix-Tag') // am letzten Samstag im November
  LWerktag(' ',10,30,'Welt-Spartag') // am letzten Werktag im Oktober (nicht Reformationstag)
  // Jahreszeitenbeginn; astron. Zyklus bis mind. 2014, ab Schaltjahr: 
  Saison( 8,20, 3,'Frhlingsanfang')           // Zyklus: 20 20 20 21
  Saison( 0,21, 6,'Sommeranfang')              // Zyklus: 21 21 21 21
  Saison(12,22, 9,'Herbstanfang') //nicht 14!  // Zyklus: 22 22 23 23
  Saison(12,21,12,'Winteranfang')              // Zyklus: 21 21 22 22
}

//Test:
//for (var Monat=2; Monat<13; Monat++)
// document.writeln('Monat '+Monat+': '+Monatslaenge(Monat, 2008)+' Tage')