// Adapted and modified from James Thiele's moonphase.js
function showMoonSized(date, halffontsize)
{
 var fontsize=2*halffontsize
 var height=1
 var i

 // Convert it to GMT
 date.setTime(date.getTime() + (date.getTimezoneOffset()*60000))

 // Compute length of lunar period -- source: World Almanac
 var lunarPeriod  = 29*(24*3600*1000) + 12*(3600*1000) + 44.05*(60*1000)

 // NOTE: months, hours, and minutes are 0 based
 // Make a Date object for time of recent new moon
 //var blueMoonDate = new Date(Date.UTC(2002, 7, 8, 18, 14) - (lunarPeriod/2))
 var blueMoonDate = new Date(Date.UTC(2004, 6, 31, 18, 05, 0) - (lunarPeriod/2))
 //var blueMoonDate = new Date(Date.UTC(2007, 5, 30, 13, 49, 0) - (lunarPeriod/2))

 // Get Date (GMT) for recent full moon

 var moonPhaseTime = (date.getTime() - blueMoonDate.getTime()) % lunarPeriod
 //alert("Moon phase in days = "+moonPhaseTime/(24*3600*1000))

 // Compute various percentages of lunar cycle
 var percentRaw = (moonPhaseTime / lunarPeriod)
 var percentBy2 = Math.round(200*percentRaw)

 var left  = (percentRaw < 0.5) ? "black.gif" : "white.gif"
 var right = (percentRaw < 0.5) ? "white.gif" : "black.gif"

 if(percentRaw >= 0.5)
 //if(percentBy2 > 100)
  percentBy2 = percentBy2 - 100

 for (i = -(halffontsize-1); i < halffontsize; ++i)
 {
  var halfwid=Math.round(parseFloat(Math.sqrt((halffontsize*halffontsize)-(i*i))))
  var wid=2*halfwid
  //if(percentBy2 == 100) percentBy2=0
  //alert("100:"+date.getDate()+"."+String(date.getMonth()+1))
  //if(percentBy2 > 0) document.write("<img src="+left +" height=1 width="+(wid*((100-percentBy2)/100))+">")
  //if(wid > fontsize) alert(String(wid)*" "+date.getDate()+"."+String(date.getMonth()+1))
  if(wid <= fontsize)
   document.write("<img src="+left +" height=1 width="+Math.round(wid*((100-percentBy2)/100))+">")
  //if(percentBy2 == 0)
  // alert("0:"+date.getDate()+"."+String(date.getMonth()+1))
  //if(percentBy2 > 0) document.write("<img src="+right+" height=1 width="+(wid*proPortion)+">")
  if(wid > 0)
   document.write("<img src="+right+" height=1 width="+Math.round(wid*((percentBy2)/100))+">")
  document.write("<br />")
 } // for
}//showMoonSized
